"use strict";

var _react = _interopRequireDefault(require("react"));

var _reactTestRenderer = _interopRequireDefault(require("react-test-renderer"));

var _Radar = _interopRequireDefault(require("../Radar"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* global test expect */
test("Renders component", function () {
  var component = _reactTestRenderer.default.create(_react.default.createElement(_Radar.default, {
    highlighted: null,
    width: 500,
    height: 500,
    padding: 70,
    domainMax: 10,
    data: {
      variables: [{
        key: "resilience",
        label: "Resilience"
      }, {
        key: "strength",
        label: "Strength"
      }, {
        key: "adaptability",
        label: "Adaptability"
      }, {
        key: "creativity",
        label: "Creativity"
      }, {
        key: "openness",
        label: "Open to Change"
      }, {
        key: "confidence",
        label: "Confidence"
      }],
      sets: [{
        key: "me",
        label: "My Scores",
        values: {
          resilience: 4,
          strength: 6,
          adaptability: 7,
          creativity: 2,
          openness: 8,
          confidence: 1
        }
      }, {
        key: "everyone",
        label: "Everyone",
        values: {
          resilience: 10,
          strength: 8,
          adaptability: 6,
          creativity: 4,
          openness: 2,
          confidence: 0
        }
      }]
    }
  }));

  var tree = component.toJSON();
  expect(tree).toMatchSnapshot();
});